if not au then

au = {}
au.bass = Sound("media/bassdrum.wav")

au.k = {halfstep = math.pow(2,1/12)}

function pitchFrom(semitone)
	return math.pow(au.k.halfstep, semitone)
end

function newTone(semitone, lenmod)
	semitone = pitchFrom(semitone or 0)
	local data = NumberArray()
	local limit = math.floor(44100 / 4 * lenmod)
	local v
	for i=0,limit do
		v = math.sin(i*math.pi/160 * semitone)/16
		v = v * math.sin(i*math.pi/limit)
		data:push_back(v) -- *((limit-i)/limit/2)
	end

	local s = bridge:soundFromValues(data)
	delete(data)
	s:setVolume(1.0)
	return s
end

function newSqTone(semitone)
	semitone = pitchFrom(semitone or 0)
	local data = NumberArray()
	local limit = math.floor((3200/semitone))-1
	local v
	local lastv = 0
	for i=0,limit do
		v = (math.sin(i*math.pi/160 * semitone) < 0 and -1 or 1)/16
		v = (v + lastv)/2
		data:push_back(v) -- *((limit-i)/limit/2)
		lastv = v
	end

	local s = bridge:soundFromValues(data)
	delete(data)
	s:setVolume(0.0)
	return s
end

function silence()
	local data = NumberArray()
	local limit = math.floor(256)-1
	for i=0,limit do
		lastv = v
	end

	local s = bridge:soundFromValues(data)
	delete(data)
	s:setVolume(0.0)
	return s
end


local aud = {0,7,12,19,24}

for i,v in ipairs(aud) do
	au[i] = newTone(v, math.pow(math.pi, 1+math.random()))
	au[i]:Play(true)
end

au.square = newSqTone(-12)
au.square:Play(true)

end

if _DEBUG then 
	function audio_reset(nobirth)
		for k,v in pairs(au) do
			if v.__delete then delete(v) end
		end
		au = nil
		if not nobirth then bridge:rebirth() end
	end
end