-- On Load

cm = {tx = 90, ty = 0}
pull(km, {whenFlip = 30*2/3, pauseFor=4, humsweep = 0.005})

local s = r(Scene())
local e = SceneEntity()
s:addEntity(e)

local res = 4
local base = Blocker()
local b = {}
base.vox[1][1][1] = true

local accum = {-.5}
for i = 1,res do
	local d = math.pow(0.5,i)
	table.insert(accum, accum[#accum] + d)
end

local camera = s:getDefaultCamera()
camera:setPosition(2,0,0)
camera:lookAt(a(Vector3(0,0,0)),a(Vector3(0,1,0)))

function updateCamera()
	e:setYaw(cm.tx)
	e:setPitch(cm.ty)
end
updateCamera()

Ent({pausing = 0, focus = 1, humticks = 1, humvol = 0,
	reset = function(self)
		self.focus = 1
		self.pausing = km.pauseFor
	end,
	onTick = function (self)
		local humgoal = (math.floor((self.humticks-1)/4) == 1) and 1 or 0
		if self.humvol < humgoal then self.humvol = self.humvol + km.humsweep
		elseif self.humvol > humgoal then self.humvol = self.humvol - km.humsweep end
		au.square:setVolume(self.humvol)
		
		if (ticks%km.whenFlip == 0) then
			if self.pausing > 0 then
				self.pausing = self.pausing - 1
				if self.pausing == 0 then 
					self.humticks = self.humticks + 1
					if self.humticks > 8 then self.humticks = 1 end
				end
			else
				au.bass:Play(false)
			
				if b[self.focus] then b[self.focus]:remove() end
				b[self.focus] = (b[self.focus-1] or base):subdivide()
				
				local d = math.pow(0.5,self.focus)
				b[self.focus]:add({e=e,d=d,o=-0.5,zo=accum[self.focus],g=(self.focus/res)})
				
				self.focus = self.focus + 1
				if self.focus > res then self:reset() end
			end
		end
	end,
	onInput = function (self)
		if down[0] then
			local off = mouseDownAt.x - mouseAt.x
			cdelete(mouseDownAt) mouseDownAt = vDup(mouseAt)
			cm.tx = cm.tx - off/4
			updateCamera()
		end
end
}):insert()

-- Set up input handler

down = {} pressed = {}
listeners = {} -- To get unicode-level key input
mouseDownAt = nil
mouseAt = nil

class "Input" (EventHandler)
function Input:Input()
	EventHandler.EventHandler(self)
end

function Input:handleEvent(e)
	if e:getDispatcher() == Services.Core:getInput() then
		local inputEvent = InputEvent(e)
		local key = inputEvent:keyCode()
		if e:getEventCode() == InputEvent.EVENT_MOUSEMOVE then
			cdelete(mouseAt) mouseAt = inputEvent:getMousePosition()
		elseif e:getEventCode() == InputEvent.EVENT_MOUSEDOWN then
			cdelete(mouseDownAt) mouseDownAt = inputEvent:getMousePosition()
			cdelete(mouseAt) mouseAt = vDup(mouseDownAt)
			down[inputEvent.mouseButton] = true
			pressed[inputEvent.mouseButton] = true
		elseif e:getEventCode() == InputEvent.EVENT_MOUSEUP then
			down[inputEvent.mouseButton] = nil
		elseif e:getEventCode() == InputEvent.EVENT_KEYDOWN then
			down[key] = true
			pressed[key] = true
			for k,v in pairs(listeners) do
				v:push({key, bridge:charCode(inputEvent)})
			end
		elseif e:getEventCode() == InputEvent.EVENT_KEYUP then
			down[key] = false
		end
	end
end

do
	input = Input()

	Services.Core:getInput():addEventListener(input, InputEvent.EVENT_MOUSEMOVE)
	Services.Core:getInput():addEventListener(input, InputEvent.EVENT_MOUSEDOWN)
	Services.Core:getInput():addEventListener(input, InputEvent.EVENT_MOUSEUP)
	Services.Core:getInput():addEventListener(input, InputEvent.EVENT_KEYDOWN)
	Services.Core:getInput():addEventListener(input, InputEvent.EVENT_KEYUP)
end